
SUP_FIELDS=(SUMMARY COMMENT)
[ -z "$values[UID]" ] && values[UID]="$(dbus-uuidgen)"

dtstart="$values[DTSTART]"
[ -z "$dtstart" ] && dtstart=$(date +%Y%m%dT%H%M%S)

echo "$dtstart" |case "$dtstart" in
  *Z)
    sed -rn 's:^([0-9]{4})([0-9]{2})([0-9]{2})T([0-9]{2})([0-9]{2})([0-9]{2})Z$:\1-\2-\3 \4\:\5\:\6 UTC:p'
    ;;
  TZID*)
    sed -rn 's:^TZID=(.+)\:([0-9]{4})([0-9]{2})([0-9]{2})T([0-9]{2})([0-9]{2})([0-9]{2})$:TZ="\1" \2-\3-\4 \5\:\6\:\7:p'
    ;;
  *)
    sed -rn 's:^([0-9]{4})([0-9]{2})([0-9]{2})T([0-9]{2})([0-9]{2})([0-9]{2})$:\1-\2-\3 \4\:\5\:\6:p'
    ;;
esac |read dts_date

dts_year=$(date -d "$dts_date" +%Y)
dts_month=$(date -d "$dts_date" +%m)
dts_dom=$(date -d "$dts_date" +%d)
dts_dow=$(date -d "$dts_date" +%u)
dts_weekday=$(date -d "$dts_date" +%A)
dts_hour=$(date -d "$dts_date" +%H)
dts_min=$(date -d "$dts_date" +%M)
dts_sec=$(date -d "$dts_date" +%S)

rrule="$values[RRULE]"
rr_int="$(echo $rrule |sed -rn 's:^.*INTERVAL=([0-9]+)(;.*)?$:\1:p')"
rr_count="$(echo $rrule |sed -rn 's:^.*COUNT=([0-9]+)(;.*)?$:\1:p')"
rr_freq="$(echo $rrule |sed -rn 's:^.*FREQ=(YEARLY|MONTHLY|WEEKLY|DAILY)(;.*)?$:\1:p')"
rr_uyear="$(echo $rrule |sed -rn 's:^.*UNTIL=([0-9]{4})([0-9]{2})([0-9]{2})T[0-9]{6}Z(;.*)?$:\1:p')"
rr_umonth="$(echo $rrule |sed -rn 's:^.*UNTIL=([0-9]{4})([0-9]{2})([0-9]{2})T[0-9]{6}Z(;.*)?$:\2:p')"
rr_uday="$(echo $rrule |sed -rn 's:^.*UNTIL=([0-9]{4})([0-9]{2})([0-9]{2})T[0-9]{6}Z(;.*)?$:\3:p')"
if [ -n "$rr_count" ]; then
  rr_limit=COUNT
elif [ -n "$rr_uyear" ]; then
  rr_limit=UNTIL
else
  rr_limit=ETERN
fi

echo '<div id="'${id}'" class="course">'
echo '<form action="/?action=update_course" method="POST">'
echo '<input type="hidden" name="course" value="'${id}'"/>'
echo '  <div class="section basic">'
echo '    <span class="sectitle">'$(l10n SUMMARY)'</span>'
echo '    <input type="text" class="item SUMMARY" name="SUMMARY" value="'$values[SUMMARY]'" />'
echo '    <span class="sectitle">'$(l10n COMMENT)'</span>'
for n in COMMENT COMMENT{0..10}; do [ -n "$values[$n]" ] &&\
  echo '    <textarea class="item COMMENT" name="COMMENT">'$values[$n]'</textarea>'
done
echo '  </div>'

echo '  <div class="section dtstart">'
echo '    <span class="sectitle">'$(l10n DTSTART)'</span>'
echo '    <select class="DTSYEAR" name="DTSYEAR" onchange="this.form.submit();">'
for y in {$(($dts_year - 50))..$(($dts_year + 50))}; do
  echo '    <option value="'$y'" '$([ "$y" -eq "$dts_year" ] && echo 'selected="selected"')'>'$y'</option>'
done
echo '    </select>'
echo '    <select class="DTSMONTH" name="DTSMONTH" onchange="this.form.submit();">'
for m in {01..12}; do
  echo '    <option value="'$m'" '$([ "$m" -eq "$dts_month" ] && echo 'selected="selected"')'>'$(date -d ${dts_year}-${m}-1 +%B)'</option>'
done
echo '    </select>'
echo '    <button class="DTS" type="submit" name="DTS" value="update">'$(l10n edit_dtscal)'</button>'
for wd in mon tue wed thu fri sat sun; do
  echo '    <span class="DTSCALHEAD">'$(date -d $wd +%a)'</span>'
done
fdom=$(date -d ${dts_year}-${dts_month}-1 +%u)
while [ "$fdom" -gt 1 ]; do
  echo '    <span class="DTSCAL"></span>'
  fdom=$(($fdom - 1))
done
echo '<input type="hidden" name="DTSDAY" value="'$dts_dom'">'
cnt=$(date -d ${dts_year}-${dts_month}-1 +%s)
while [ "$(date -d @$cnt +%m)" = "$dts_month" ]; do
  dn=$(date -d @$cnt +%d)
  echo '    <button class="DTSCAL '$( [ $dn = $dts_dom ] && echo selected)'" type="submit" name="DTSDAY" value="'$dn'">'$dn'</button>'
  cnt=$(($cnt + 86400))
done
echo '    <br />'
echo '    <span class="DTSTIME">'$(l10n time)':</span>'
echo '    <select class="DTSTIME" name="DTSHOUR">'
for h in {00..23}; do
  echo '    <option value="'$h'" '$([ "$h" -eq "$dts_hour" ] && echo 'selected="selected"')'>'$h'</option>'
done
echo '    </select>:<select class="DTSTIME" name="DTSMINUTE">'
for m in 00 05 10 15 20 25 30 35 40 45 50 55; do
  echo '    <option value="'$m'" '$([ "$m" -eq "$dts_min" ] && echo 'selected="selected"')'>'$m'</option>'
done
echo '    </select>'
echo '  </div>'

echo '  <div class="section recur">'
echo '    <span class="sectitle">'$(l10n RRULE)'</span>'
echo '    <span class="text">'$(l10n t_every)'</span>'
echo '    <select class="RRULE INTERVAL" name="RRULE_INTERVAL">'
for i in {1..365}; do
  echo '    <option value="'$i'" '$([ "$i" = "$rr_int" ] && echo 'selected="selected"')'>'$i'</option>'
done
echo '    </select>'
echo '    <select class="RRULE FREQ" name="RRULE_FREQ">'
for f in DAILY WEEKLY MONTHLY YEARLY; do
  echo '    <option value="'$f'" '$([ "$f" = "$rr_freq" ] && echo 'selected="selected"')'>'$(l10n $f)'</option>'
done
echo '    </select><br/>'
echo '    <input type="radio" name="RRULE_LIMIT" value="ETERN" '$([ "$rr_limit" = ETERN ] && echo 'checked="checked"')'>'$(l10n t_eternal)'</input><br/>'
echo '    <input type="radio" name="RRULE_LIMIT" value="COUNT" '$([ "$rr_limit" = COUNT ] && echo 'checked="checked"')'></input>'
echo '    <select class="RRULE COUNT" name="RRULE_COUNT">'
for t in {1..365}; do
  echo '    <option value="'$t'" '$([ "$t" = "$rr_count" ] && echo 'selected="selected"')'>'$t'</option>'
done
echo '    </select><span class="text">'$(l10n t_times)'</span><br/>'
echo '    <input type="radio" name="RRULE_LIMIT" value="UNTIL" '$([ "$rr_limit" = UNTIL ] && echo 'checked="checked"')'>'$(l10n t_until)'</input>'
echo '    <select class="RRULE UYEAR" name="RRULE_UYEAR">'
for uy in {${dts_year}..$(($dts_year + 50))}; do
  echo '    <option value="'$uy'" '$([ "$uy" = "$rr_uyear" ] && echo 'selected="selected"')'>'$uy'</option>'
done
echo '    </select>'
echo '    <select class="RRULE UMONTH" name="RRULE_UMONTH">'
for um in {01..12}; do
  echo '    <option value="'$um'" '$([ "$um" = "$rr_umonth" ] && echo 'selected="selected"')'>'$(date -d 2000-${um}-1 +%B)'</option>'
done
echo '    </select>'
echo '    <select class="RRULE UDAY" name="RRULE_UDAY">'
for ud in {01..31}; do
  echo '    <option value="'$ud'" '$([ "$ud" = "$rr_uday" ] && echo 'selected="selected"')'>'$ud'</option>'
done
echo '    </select>'
echo '  </div>'

echo '  <div class="section select_attendance">'
echo '    <span class="sectitle">'$(l10n course_attendance)'</span>'
echo '    <select class="item attendance" name="attendance" multiple="multiple">'
listcards |while read card; do
  cfile="$_DATA/vcard/$card"
  aname=$(sed -rn 's:^N(;[^"\:]+|;"[^"]+")*\:([^;]*)(\;[^;]*)(\;[^;]*)?(\;[^;]*)?(\;[^;]*)?$:\5 \3 \4 \2 \6:p' "$cfile" \
          |sed -r 's:,: :;s:\;: :g;s: +: :g' \
          |tr -d '\r'
         )
  selected=$(sed -rn "s:^$id\t$card\$:selected=\"selected\":p" $_DATA/mappings/attendance)
  echo '    <option value="'$card'" '$selected'>'$aname'</option>'
done
echo '    </select>'
echo '  </div>'

echo '  <div class="section control">'
echo '    <button class="item control" type="submit" name="action" value="addfield">'$(l10n edit_addfield)'</button>'
echo '    <select class="item control" name="newfield">'
echo '      <option value="" disabled="disabled" selected="selected">'$(l10n edit_addfieldtext)'</option>'
            for f in $SUP_FIELDS; do echo "<option value=\"$f\">$(l10n $f)</option>"; done
echo '    </select>'
echo '    <button class="item control" type="submit" name="action" value="update">'$(l10n edit_update)'</button>'
echo '    <button class="item control" type="submit" name="action" value="delete">'$(l10n edit_delete)'</button>'
echo '    <button class="item control" type="submit" name="action" value="cancel">'$(l10n edit_cancel)'</button>'
echo '  </div>'
echo '<input type="hidden" name="UID" value="'$values["UID"]'"/>'
echo '</form>'
echo '</div>'

